# coding: utf-8

"""
    Antimatter Public API

    Interact with the Antimatter Cloud API

    The version of the OpenAPI document: 2.0.9
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from antimatter_api.models.google_o_auth_domain_identity_provider_details_group_mappings import GoogleOAuthDomainIdentityProviderDetailsGroupMappings
from typing import Optional, Set
from typing_extensions import Self

class GoogleOAuthDomainIdentityProviderDetails(BaseModel):
    """
    Detailed information about a Google OAuth identity provider. If the clientID is omitted, an Antimatter Client ID will be used. 
    """ # noqa: E501
    client_id: Optional[StrictStr] = Field(default=None, alias="clientID")
    group_mappings: Optional[GoogleOAuthDomainIdentityProviderDetailsGroupMappings] = Field(default=None, alias="groupMappings")
    __properties: ClassVar[List[str]] = ["clientID", "groupMappings"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GoogleOAuthDomainIdentityProviderDetails from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of group_mappings
        if self.group_mappings:
            _dict['groupMappings'] = self.group_mappings.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GoogleOAuthDomainIdentityProviderDetails from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "clientID": obj.get("clientID"),
            "groupMappings": GoogleOAuthDomainIdentityProviderDetailsGroupMappings.from_dict(obj["groupMappings"]) if obj.get("groupMappings") is not None else None
        })
        return _obj


