# coding: utf-8

"""
    Antimatter Public API

    Interact with the Antimatter Cloud API

    The version of the OpenAPI document: 2.0.9
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from antimatter_api.models.set_data_policy_binding_read_contexts_inner import SetDataPolicyBindingReadContextsInner
from typing import Optional, Set
from typing_extensions import Self

class SetDataPolicyBinding(BaseModel):
    """
    SetDataPolicyBinding
    """ # noqa: E501
    read_contexts: Optional[List[SetDataPolicyBindingReadContextsInner]] = Field(default=None, alias="readContexts")
    default_attachment: StrictStr = Field(alias="defaultAttachment")
    __properties: ClassVar[List[str]] = ["readContexts", "defaultAttachment"]

    @field_validator('default_attachment')
    def default_attachment_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['Inherit', 'NotAttached', 'Attached']):
            raise ValueError("must be one of enum values ('Inherit', 'NotAttached', 'Attached')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SetDataPolicyBinding from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in read_contexts (list)
        _items = []
        if self.read_contexts:
            for _item in self.read_contexts:
                if _item:
                    _items.append(_item.to_dict())
            _dict['readContexts'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SetDataPolicyBinding from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "readContexts": [SetDataPolicyBindingReadContextsInner.from_dict(_item) for _item in obj["readContexts"]] if obj.get("readContexts") is not None else None,
            "defaultAttachment": obj.get("defaultAttachment")
        })
        return _obj


